use crate::types::structs::message_sender::MessageSenderBuilder;
use telers::{types::Message, Bot};

pub type ExtractedEntityData = (Bot, Message, MessageSenderBuilder);

pub struct HandlerEntity {
    pub bot_instance: Bot,
    pub message_reciever: Message,
    pub message_sender_builder: MessageSenderBuilder,
}

impl HandlerEntity {
    pub fn new(bot: Bot, msg: Message, msg_builder: MessageSenderBuilder) -> Self {
        Self {
            bot_instance: bot,
            message_reciever: msg,
            message_sender_builder: msg_builder,
        }
    }
    #[inline]
    pub fn extract(self) -> ExtractedEntityData {
        (
            self.bot_instance,
            self.message_reciever,
            self.message_sender_builder,
        )
    }
}
